/*
 * sp1.h
 *
 * SP1-Parti definitions, macros, and function prototypes...
 * Version 1.0
 *					shin 10/4/93 
 */

/* IBM SP-1 header files */
#include <mpceui.h>
#include <mpctof.c>

/*
 * Global variables
 /*

/* variables for SP-1 communication functions */
extern	int	PARTI_source;		/* source node of incoming message */
extern	int	PARTI_type;		/* type of incoming message */
extern	int	PARTI_nbytes;		/* number of bytes received */

/*
 * Definitions
 */

/* tags for force type message */
#define FORCED_GATHER_EXECUTOR_MSG      10000
#define FORCED_SCATTER_EXECUTOR_MSG     20000
#define FORCED_ADD_EXECUTOR_MSG         30000
#define FORCED_SUB_EXECUTOR_MSG         40000
#define FORCED_MULT_EXECUTOR_MSG        50000

/* tags for unforce type message */
#define GATHER_EXECUTOR_MSG             00000
#define SCATTER_EXECUTOR_MSG            10000
#define ADD_EXECUTOR_MSG                20000
#define SUB_EXECUTOR_MSG                30000
#define MULT_EXECUTOR_MSG               40000

/* tags for synchronizing message */
#define GATHER_SYNC                     50000
#define SCATTER_SYNC                    60000
#define ADD_SYNC                        70000
#define SUB_SYNC                        80000
#define MULT_SYNC                       90000

/* tags used in bisection routine */
#define  EXCHEVEN                       01000
#define  EXCHODD                        01500
#define  REVEVEN                        02000
#define  REVODD                         02500
#define  DISTEVEN                       03000
#define  DISTODD                        03500


#define MAXNODES                        512
#define MAXCOUNT                        10

#define TABLE_REMAP                     17000
#define MSG_TTABLE                      18097
#define MSG_PROC                        15500
#define MSG_OFFS                        25500

#define PARTI_ANY_NODE                  DONTCARE 

/*
 * IBM SP-1 Communication Routines
 */
#define PARTI_numprocs()	mpc_numnodes()
#define PARTI_myproc()		mpc_mynode()
#define PARTI_mypid()		(0)
#define PARTI_infonode()	(PARTI_source)
#define PARTI_infocount()	(PARTI_nbytes)
#define PARTI_infotype()	(PARTI_type)

#define PARTI_gsync()		mpc_sync(ALLGRP)
#define	PARTI_dclock()		dclock()
#define PARTI_bsend(tag,buf,len,node,pid) \
				mpc_bsend(buf,(int)len,node,tag)
#define PARTI_csend(tag,buf,len,node,pid) \
				mpc_bsend(buf,(int)len,node,tag)
#define PARTI_isend(tag,buf,len,node,pid) \
				mpc_isend(tag,buf,(int)len,node)
#define PARTI_crecv(tag,buf,len,node,pid) \
				mpc_crecv(tag,buf,(int)len,node)
#define PARTI_irecv(tag,buf,len,node,pid) \
				mpc_irecv(tag,buf,(int)len,node)
#define PARTI_msgwait(id)	mpc_wait(&id,&PARTI_nbytes)
#define PARTI_cprobe(id)	mpc_probe(id)
#define PARTI_iprobe(id)	

#define PARTI_gisum(x,n,work)	mpc_gisum(x,n,work)
#define PARTI_gihigh(x,n,work)	mpc_gihigh(x,n,work)
#define PARTI_gilow(x,n,work)	mpc_gilow(x,n,work)
#define PARTI_gssum(x,n,work)   mpc_gssum(x,n,work)
#define PARTI_gshigh(x,n,work)  mpc_gshigh(x,n,work)
#define PARTI_gslow(x,n,work)   mpc_gslow(x,n,work)
#define PARTI_gdsum(x,n,work)   mpc_gdsum(x,n,work)
#define PARTI_gdhigh(x,n,work)  mpc_gdhigh(x,n,work)
#define PARTI_gdlow(x,n,work)   mpc_gdlow(x,n,work)
/* xlen must be equal for all processors (constrant from CM5 CMMD) */
#define PARTI_gcol(x,xlen,y,ylen,work) \
				mpc_concat(x,y,(int)xlen,ALLGRP)
